on run
	my show_all()
end run

on show_all()
	tell application "Mousepose"
		set theWindow to window "Main"
		set theTabView to tab view "Tabs" of window "Main"
		try
			set uses timeout to false
			set overlay opacity to 40
			set overlay color to {0, 0, 0}
			set animates start and stop to true
			set window focus to false
			
			set current tab view item of theTabView to tab view item "effect" of theTabView
			
			activate
			show window "Main"
			start effect
			
			set effect blur to 50
			start effect
			set x to theTabView
			my pointToTheButton(x)
			
			my csay("Welcome to Boinx Mousepos three!")
			delay 1
			set theBlur to 40
			set effect blur to theBlur
			my csay("This short tour will walk you through the most common settings of Mousepos.")
			delay 1
			
			set j to effect size
			repeat with i from 70 to j by 20
				set effect size to (j - i) + 70
				set effect blur to 40 - (i * theBlur / j)
				delay 0.1
			end repeat
			
			
			my show_effect()
			my show_clicks()
			my show_keys()
			my advertise_me()
			
		on error
			my error_handler()
		end try
		
		stop effect
		my say_bye()
		delay 0.5
	end tell
	
end show_all


on show_effect()
	tell application "Mousepose"
		set theWindow to window "Main"
		set theTabView to tab view "Tabs" of window "Main"
		
		set current tab view item of theTabView to tab view item "effect" of theTabView
		
		set x to control "HotKey" of view "activation" of view of tab view item "effect" of theTabView
		
		if overlay opacity is greater than 50 or overlay opacity is less than 10 then
			set overlay opacity to 30
		end if
		
		delay 0.1
		my introduce(x)
		
		set t to (string value of x)
		my csay("Your current hot key is " & t & ".")
		delay 1
		
		set x to slider "Size Slider" of view "options" of view of tab view item "effect" of theTabView
		my introduce(x)
		repeat with i from 10 to 300 by 10
			set effect size to i
			delay 0.1
		end repeat
		repeat with i from 10 to 230 by 15
			set effect size to (300 - i)
			delay 0.1
		end repeat
		
		set o to effect blur
		set x to slider "Blur Slider" of view "options" of view of tab view item "effect" of theTabView
		my introduce(x)
		repeat with i from 0 to 100 by 5
			set effect blur to i
			delay 0.1
		end repeat
		repeat with i from 5 to 95 by 10
			set effect blur to (100 - i)
			delay 0.1
		end repeat
		set effect blur to o
		
		set o to overlay opacity
		set x to slider "Opacity Slider" of view "options" of view of tab view item "effect" of theTabView
		my introduce(x)
		repeat with i from 10 to 100 by 5
			set overlay opacity to i
			delay 0.1
		end repeat
		repeat with i from 10 to 50 by 5
			set overlay opacity to (100 - i)
			delay 0.1
		end repeat
		set overlay opacity to o
		set myColor to overlay color
		
		set overlay color to myColor
		delay 1
		
		if (system attribute "sys2") is greater than 4 then
			
			set x to button "window focus" of view "options" of view of tab view item "effect" of theTabView
			my pointToTheButton(x)
			my csay("New in Mousepose three is window focus")
			set window focus to true
			my introduce(x)
			delay 2
			set window focus to false
			delay 2
			
		end if
	end tell
end show_effect


on show_clicks()
	tell application "Mousepose"
		set theWindow to window "Main"
		set theTabView to tab view "Tabs" of window "Main"
		
		set current tab view item of theTabView to tab view item "clicks" of theTabView
		set x to view "TabControl" of window "Main"
		my introduce(x)
		my csay("As of Mousepos 3 you can now visualize mouse clicks alone:")
		delay 0.5
		
		set play click sound to false
		
		start mouse click visualization
		
		if (system attribute "sys2") is greater than 4 then
			
			set x to view "clickArea" of view "clickOptions" of view of tab view item "clicks" of theTabView
			my introduce(x)
			delay 0.5
			my csay("You can visualize single")
			
			-- set some mouse click events here!
			perform single left click
			
			delay 0.5
			
			my csay("and double mouse clicks.")
			
			perform double left click
			
			delay 1
			
			my csay("Mouse clicks with right mouse button are drawn in a different color")
			
			perform single right click
			
			delay 1
			
		end if
		
		set play click sound to true
		
		set x to button "playClickSound" of view "clickOptions" of view of tab view item "clicks" of theTabView
		my pointToTheButton(x)
		my csay("Also an audio feedback is given to a mouse click, if Play Click Sound is activated")
		set x to view "clickArea" of view "clickOptions" of view of tab view item "clicks" of theTabView
		
		perform single left click
		
		delay 1.0
		
		set play click sound to false
		
		stop mouse click visualization
		
		set x to matrix "MouseClickBehavior" of view "clickActivation" of view of tab view item "clicks" of theTabView
		my introduce(x)
		delay 1
		
		set x to view "clickOptions" of view of tab view item "clicks" of theTabView
		my introduce(x)
		delay 1
		
	end tell
	
end show_clicks


on show_keys()
	tell application "Mousepose"
		set theWindow to window "Main"
		set theTabView to tab view "Tabs" of window "Main"
		set current tab view item of theTabView to tab view item "keystroke" of theTabView
		set x to view "TabControl" of window "Main"
		my introduce(x)
		my csay("You can also visualize keystrokes in a bar along the bottom of the screen:")
		
		delay 0.1
		
		stop effect
		delay 0.1
		start keystroke display without notification
		
		display keystrokes "This is an example display..." fading out after 2.0
		delay 2.0
		stop keystroke display without notification
		delay 0.1
		start effect
		
		set x to matrix "keystrokeBehavior" of view "keystrokeActivation" of view of tab view item "keystroke" of theTabView
		my introduce(x)
		delay 1
		
		set x to view "keystrokeOptions" of view of tab view item "keystroke" of theTabView
		my introduce(x)
		delay 1
		
	end tell
end show_keys


on advertise_me()
	tell application "Mousepose"
		set x to button "BuyNow" of window "Main"
		if x is visible then
			set effect size to 30
			my csay("And: ")
			delay 0.2
			start effect
			my introduce(x)
			stop effect
		end if
	end tell
end advertise_me

on error_handler()
	tell application "Mousepose"
		stop effect
		stop mouse click visualization
		stop keystroke display
	end tell
end error_handler

on say_bye()
	tell application "Mousepose"
		my csay("Thankyou. Enjoy using Boinx Mousepos!")
	end tell
end say_bye


-- helpers

on introduce(b)
	tell application "Mousepose"
		my pointToTheButton(b)
		my pointToTheButton(b)
		if exists (tool tip of b) then my csay((tool tip of b) as string)
	end tell
end introduce

on pointToTheButton(b)
	tell application "Mousepose"
		set butPos to my absolutePositionOfTheView(b)
		set butSize to size of b
		set x to (item 1 of butPos) + (item 1 of butSize) / 2
		set y to (item 2 of butPos) + (item 2 of butSize) / 2
		if item 1 of butSize > item 2 of butSize then
			set newEffectSize to (item 1 of butSize) / 2 + 4
		else
			set newEffectSize to (item 2 of butSize) / 2 + 4
		end if
		set newMouseLocation to {x, y}
	end tell
	my animateToSizeAndPosition(newEffectSize, newMouseLocation)
end pointToTheButton


on animateToSizeAndPosition(newEffectSize, newMouseLocation)
	tell application "Mousepose"
		set effect size to newEffectSize
		set mouse location to {item 1 of newMouseLocation, item 2 of newMouseLocation}
	end tell
end animateToSizeAndPosition

on absolutePositionOfTheView(theView)
	if ((AppleScript's version) as string) starts with "2." then
		return absolutePositionOfTheViewTiger(theView)
	else if ((AppleScript's version) as string) starts with "1.10" then
		return absolutePositionOfTheViewTiger(theView)
	else
		return absolutePositionOfTheViewPanther(theView)
	end if
end absolutePositionOfTheView

on absolutePositionOfTheViewPanther(theView)
	tell application "Mousepose"
		set {x, y} to position of theView
		set pos to position of window "Main"
		set x to x + (item 1 of pos)
		set y to y + (item 2 of pos)
		return {x, y}
	end tell
end absolutePositionOfTheViewPanther

on absolutePositionOfTheViewTiger(theView)
	tell application "Mousepose"
		set {x, y} to position of theView
		set sv to super view of theView
		repeat until sv is content view of window "Main"
			set pos to position of sv
			set x to x + (item 1 of pos)
			set y to y + (item 2 of pos)
			set sv to super view of sv
		end repeat
		set pos to position of window "Main"
		set x to x + (item 1 of pos)
		set y to y + (item 2 of pos) - 4
		return {x, y}
	end tell
end absolutePositionOfTheViewTiger

on csay(t) -- corrected say	
	set t to replace_chars(t, "Boinx", "Boings")
	set t to replace_chars(t, "Mousepos", "[[inpt phon]] m1AWspOWz1EY [[inpt text]]")
	set t to quoted form of t
	do shell script "say -v Alex " & t
end csay

on replace_chars(this_text, search_string, replacement_string)
	set AppleScript's text item delimiters to the search_string
	set the item_list to every text item of this_text
	set AppleScript's text item delimiters to the replacement_string
	set this_text to the item_list as string
	set AppleScript's text item delimiters to ""
	return this_text
end replace_chars
